"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../services/utils");
const rules_1 = __importDefault(require("../validation/rules"));
const baseNode_1 = __importDefault(require("./baseNode"));
class ControlNode extends baseNode_1.default {
    constructor({ name, value }) {
        var _a;
        super(name, 'control');
        const definitions = Object.entries(value);
        this.validators = definitions
            .map(([name, definition]) => rules_1.default(name, definition))
            .filter((v) => utils_1.isString(v));
        this.disabled = definitions.map(([name]) => name).includes('readOnly');
        this.defaultValue = (_a = value['default']) !== null && _a !== void 0 ? _a : null;
    }
    static transformDefaultValue(value) {
        if (value === null) {
            return 'null';
        }
        if (utils_1.isString(value)) {
            return `"${value}"`;
        }
        // TODO: fix
        return value;
    }
    build() {
        var _a, _b;
        const { defaultValue } = this;
        const transformedValue = ControlNode.transformDefaultValue(defaultValue);
        return `${this.name}: new FormControl({
      value: ${transformedValue.toString()},
      disabled: ${this.disabled.toString()},
    }, [${(_b = (_a = this.validators) === null || _a === void 0 ? void 0 : _a.join(', ')) !== null && _b !== void 0 ? _b : ''}])`;
    }
}
exports.default = ControlNode;
//# sourceMappingURL=controlNode.js.map