"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ngx_openapi_types_1 = require("../contracts/ngx-openapi-types");
const arrayNode_1 = __importDefault(require("../nodes/arrayNode"));
const controlNode_1 = __importDefault(require("../nodes/controlNode"));
const groupNode_1 = __importDefault(require("../nodes/groupNode"));
const utils_1 = require("./utils");
const entityMapper = (type) => (e, p) => {
    switch (type) {
        case ngx_openapi_types_1.DataType.Object:
            return new groupNode_1.default(e, buildNode, p);
        case ngx_openapi_types_1.DataType.Array:
            return new arrayNode_1.default(e);
        case ngx_openapi_types_1.DataType.String:
        case ngx_openapi_types_1.DataType.Boolean:
        case ngx_openapi_types_1.DataType.Number:
        case ngx_openapi_types_1.DataType.Integer:
            return new controlNode_1.default(e);
        default:
            throw new Error(`Can not create node for type: ${type}`);
    }
};
const buildNode = (entity, parent) => {
    if (utils_1.isNil(entity)) {
        throw new Error('Entity can not be null');
    }
    const { value: { type } } = entity;
    return entityMapper(type)(entity, parent);
};
exports.default = buildNode;
//# sourceMappingURL=node-builder.js.map