"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isArrayDefinition = exports.isObjectDefinition = exports.isEnum = exports.isPrimitive = exports.isMergedDefinition = exports.isPrimitiveDataType = exports.hasPresentKey = exports.isString = exports.isNil = void 0;
const ngx_openapi_types_1 = require("../contracts/ngx-openapi-types");
const isNil = (value) => {
    return value === null || value === undefined;
};
exports.isNil = isNil;
const isString = (value) => {
    return typeof value === 'string';
};
exports.isString = isString;
function hasPresentKey(k) {
    return function (a) {
        return !exports.isNil(a[k]);
    };
}
exports.hasPresentKey = hasPresentKey;
const isPrimitiveDataType = (value) => {
    return value !== ngx_openapi_types_1.DataType.Array && value !== ngx_openapi_types_1.DataType.Object;
};
exports.isPrimitiveDataType = isPrimitiveDataType;
const isMergedDefinition = (schema) => {
    return !!schema.allOf;
};
exports.isMergedDefinition = isMergedDefinition;
const isPrimitive = (schema) => {
    return !exports.isMergedDefinition(schema) && exports.isPrimitiveDataType(schema.type);
};
exports.isPrimitive = isPrimitive;
const isEnum = (schema) => {
    return !!schema.enum;
};
exports.isEnum = isEnum;
const isObjectDefinition = (schema) => {
    return !exports.isMergedDefinition(schema) && schema.type === ngx_openapi_types_1.DataType.Object;
};
exports.isObjectDefinition = isObjectDefinition;
const isArrayDefinition = (schema) => {
    return !exports.isMergedDefinition(schema) && schema.type === ngx_openapi_types_1.DataType.Array;
};
exports.isArrayDefinition = isArrayDefinition;
//# sourceMappingURL=utils.js.map